Package org.apache.lucene.search

## Class ConstantScoreQuery

- java.lang.Object
- - org.apache.lucene.search.Query
  - - org.apache.lucene.search.ConstantScoreQuery

-     public final class ConstantScoreQuery
      extends Query

  A query that wraps another query and simply returns a constant score equal to 1 for every document that matches the query. It therefore simply strips of all scores and always returns 1.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `protected static class` | `ConstantScoreQuery.ConstantBulkScorer` | We return this as our `BulkScorer` so that if the CSQ wraps a query with its own optimized top-level scorer (e.g.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ConstantScoreQuery​(Query query)` | Strips off scores from the passed in Query.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Weight` | `createWeight​(IndexSearcher searcher, ScoreMode scoreMode, float boost)` | Expert: Constructs an appropriate Weight implementation for this query.
    `boolean` | `equals​(Object other)` | Override and implement query instance equivalence properly in a subclass.
    `Query` | `getQuery()` | Returns the encapsulated query.
    `int` | `hashCode()` | Override and implement query hash code properly in a subclass.
    `Query` | `rewrite​(IndexSearcher indexSearcher)` | Expert: called to re-write queries into primitive queries.
    `String` | `toString​(String field)` | Prints a query to a string, with `field` assumed to be the default field and omitted.
    `void` | `visit​(QueryVisitor visitor)` | Recurse through the query tree, visiting any child queries.

    - ### Methods inherited from class org.apache.lucene.search.Query

      `classHash, rewrite, sameClassAs, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ConstantScoreQuery

          public ConstantScoreQuery​(Query query)

      Strips off scores from the passed in Query. The hits will get a constant score of 1.

  - ### Method Detail

    - #### getQuery

          public Query getQuery()

      Returns the encapsulated query.

    - #### rewrite

          public Query rewrite​(IndexSearcher indexSearcher)
                        throws IOException

      Description copied from class: `Query`
      Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

      Callers are expected to call `rewrite` multiple times if necessary, until the rewritten query is the same as the original query.

      The rewrite process may be able to make use of IndexSearcher's executor and be executed in parallel if the executor is provided.

      However, if any of the intermediary queries do not satisfy the new API, parallel rewrite is not possible for any subsequent sub-queries. To take advantage of this API, the entire query tree must override this method.

      Overrides:
        `rewrite` in class `Query`
      Throws:
        `IOException`
      See Also:
        `IndexSearcher.rewrite(Query)`

    - #### visit

          public void visit​(QueryVisitor visitor)

      Description copied from class: `Query`
      Recurse through the query tree, visiting any child queries.
      Specified by:
        `visit` in class `Query`
      Parameters:
        `visitor` - a QueryVisitor to be called by each query in the tree

    - #### createWeight

          public Weight createWeight​(IndexSearcher searcher,
                                     ScoreMode scoreMode,
                                     float boost)
                              throws IOException

      Description copied from class: `Query`
      Expert: Constructs an appropriate Weight implementation for this query.

      Only implemented by primitive queries, which re-write to themselves.

      Overrides:
        `createWeight` in class `Query`
        `scoreMode` - How the produced scorers will be consumed.
        `boost` - The boost that is propagated by the parent queries.
      Throws:
        `IOException`

    - #### toString

          public String toString​(String field)

      Description copied from class: `Query`
      Prints a query to a string, with `field` assumed to be the default field and omitted.
      Specified by:
        `toString` in class `Query`

    - #### equals

          public boolean equals​(Object other)

      Description copied from class: `Query`
      Override and implement query instance equivalence properly in a subclass. This is required so that `QueryCache` works properly.

      Typically a query will be equal to another only if it's an instance of the same class and its document-filtering properties are identical to those of the other instance. Utility methods are provided for certain repetitive code.

      Specified by:
        `equals` in class `Query`
      See Also:
        `Query.sameClassAs(Object)`, `Query.classHash()`

    - #### hashCode

          public int hashCode()

      Description copied from class: `Query`
      Override and implement query hash code properly in a subclass. This is required so that `QueryCache` works properly.
      Specified by:
        `hashCode` in class `Query`
      See Also:
        `Query.equals(Object)`